
set echo on
set serveroutput on

DECLARE

   TYPE varchar2_array IS TABLE OF VARCHAR2(30)
      INDEX BY BINARY_INTEGER;

   TYPE record_type IS RECORD
   (  inner_array varchar2_array );

   TYPE varchar2_multi IS TABLE OF record_type
      INDEX BY BINARY_INTEGER;

   outer_array varchar2_multi;

BEGIN

   outer_array(1).inner_array(1) := 'one and one';
   outer_array(1).inner_array(2) := 'one and two';
   outer_array(1).inner_array(3) := 'one and three';

   DBMS_OUTPUT.PUT_LINE(
      'Count of inner array at outer array element one is [' ||
      outer_array(1).inner_array.COUNT || '].'
      );

   DBMS_OUTPUT.PUT_LINE(
      'Inner array element two at outer array element one is [' ||
      outer_array(1).inner_array(2) || '].'
      );

END;
/

