set serveroutput on

--
-- This program will find the "break-point" for multilevel collection nesting.
-- Do not run this on a "live" system...
--

declare
   s dbms_sql.varchar2s;
   c binary_integer;
   n pls_integer := 2000;
begin
   loop
      s(s.count+1) := 'declare';
      s(s.count+1) := ' type a0 is table of integer;';
      for i in 1 .. n loop
         s(s.count+1) := 'type a'||to_char(i)||' is table of a'||to_char(i-1)||';';
      end loop;
      s(s.count+1) := 'begin null; end;';
      c := dbms_sql.open_cursor;
      dbms_sql.parse(c,s,1,s.count,true,dbms_sql.native);
      dbms_sql.close_cursor(c);
      s.delete;
      n := n + 1;
   end loop;
exception
   when others then 
      dbms_output.put_line(sqlerrm);
      dbms_output.put_line('Failed with ' || n || ' levels of nesting.');
end;
/

      

